-- By .ranu. and auahdark (MikuAuahDark)
-- Open the .map file
print("HI")
local map_folder = "maps/"
local map = "cs_italy.map"
local map_orig = io.open(map_folder .. map, "rb")
print("MAP : " .. map)

-- local function readInt(file)
    -- local b1, b2, b3, b4 = file:read(1):byte(), file:read(1):byte(), file:read(1):byte(), file:read(1):byte()
    -- return b1 + b2 * 256 + b3 * 65536 + b4 * 16777216
-- end

-- def read_cs2d_string(f: IO[bytes]) -> str:
  -- buf: list[bytes] = []
  -- while len(buf) < 2 or (buf[-2] != b"\r" and buf[-1] != b"\n"):
    -- buf.append(f.read(1))
  -- return str(b"".join(buf[:-2]), "windows-1252")

local function dwordize(f) -- readInt
  local a, b, c, d = f:read(4):byte(1, 4)
  return a + b * 256 + c * 65536 + d * 16777216
end

local function readShort(file)
    local b1, b2 = file:read(1):byte(), file:read(1):byte()
    return b1 + b2 * 256
end

local function readByte(file)
    return file:read(1):byte()
end

-- Helper function to read a string
local function readString(file)
    return file:read("*l")
end

-- Read the tile indices for the entire map
local function readTileIndices(file, map_width, map_height)
    local tile_indices = {}
    for x = 0, map_width do
        tile_indices[x] = {}
        for y = 0, map_height do
            tile_indices[x][y] = readByte(file)
        end
    end
    return tile_indices
end

-- Read the tile modifiers if "use_map_modifiers" is set
local function readTileModifiers(file, map_width, map_height)
    local tile_modifiers = {}
    for x = 0, map_width do
        tile_modifiers[x] = {}
        for y = 0, map_height do
            local modifier = readByte(file)
            tile_modifiers[x][y] = { modifier = modifier }
            
            -- Check additional data based on the modifier byte
			-- if bit.band(modifier, 64) > 0 or bit.band(modifier, 128) > 0 then not supported in lua 5.1
            if modifier >= 64 then
                if modifier >= 192 then
                    tile_modifiers[x][y].unused_string = readString(file)
                elseif modifier >= 128 then
                    tile_modifiers[x][y].color = {
                        red = readByte(file),
                        green = readByte(file),
                        blue = readByte(file)
                    }
                    tile_modifiers[x][y].overlay_frame = readByte(file)
                else
                    tile_modifiers[x][y].frame = readByte(file)
                end
            end
        end
    end
    return tile_modifiers
end

local Header = readString(map_orig) -- Unreal Software's Counter-Strike 2D Map File (max)
print(Header)

-- map_orig:read(1) -- empty bytes
local scroll_background_like_tiles = tonumber(map_orig:read(1):byte()) -- BYTE scroll map like tiles? (0 no / 1 yes)

-- if scroll_background_like_tiles ~= 0 and scroll_background_like_tiles ~= 1 then
	-- local remaining_fix = map_orig:read(12)
	
	-- scroll_background_like_tiles = tonumber(map_orig:read(1):byte()) -- BYTE scroll map like tiles? (0 no / 1 yes)
	-- print("FIXED MISSING REMAINING ERROR : " .. Header ..  remaining_fix)
-- end

local modifiers = tonumber(map_orig:read(1):byte()) -- BYTE use modifiers in this map (blending, tile rotation, tile brightness) (0 no / 1 yes)
local save_tileheights = tonumber(map_orig:read(1):byte()) -- BYTE save tile heights with map? (0 no / 1 / 2) - this value defaults to 2 since 1.0.0.3, was 0 before
local tiles_64x64 = tonumber(map_orig:read(1):byte()) -- BYTE use 64x64 pixel tiles? (0 no / 1 yes) - this defaults to 0 which means 32x32 pixel tiles

map_orig:read(6) -- unused bytes

print("scroll_background_like_tiles: " .. scroll_background_like_tiles)
print("MODIFIERS: " .. modifiers)
print("SAVE TILE HEIGHT ? : " .. save_tileheights)
print("64x64 tiles ? : " .. tiles_64x64)

print(Header)
local uptime = dwordize(map_orig) -- INT Uptime of system (in millisecs) when map has been saved
print("System Uptime when map saved:", uptime)

local usgn = dwordize(map_orig) - 51 -- INT USGN ID of the map author with an offset of +51 (0 if author was not logged in)
print("USGN : " .. usgn)

local daylight_time = dwordize(map_orig) - 1000
print("DaylightTime : " .. daylight_time) -- INT Map daylight time: value from 0 to 360 + 1000 (0 if not specified, will fall back to 225 then)

-- Continue reading the rest of the map settings
local unused_int1 = dwordize(map_orig)
local unused_int2 = dwordize(map_orig)
local unused_int3 = dwordize(map_orig)
local unused_int4 = dwordize(map_orig)
local unused_int5 = dwordize(map_orig)
local unused_int6 = dwordize(map_orig)
local unused_int7 = dwordize(map_orig)

-- Read the strings for the map settings/info
local author_name = readString(map_orig) -- STRING name of the map author
local saving_program = readString(map_orig) -- STRING name of the program used to save the map (since 1.0.0.3, e.g.: "CS2D Client 1.0.0.3")

-- unused
local unused_str1 = readString(map_orig)
local unused_str2 = readString(map_orig)
local unused_str3 = readString(map_orig)
local unused_str4 = readString(map_orig)
local unused_str5 = readString(map_orig)
local unused_str6 = readString(map_orig)
local unused_str7 = readString(map_orig)
local unused_str8 = readString(map_orig)

-- Output to verify the strings
print("Author Name:", author_name)
print("Saving Program:", saving_program)

-- for i = 1, 51 do
	-- print(map_orig:read(1):byte())
-- end

if modifiers == 1 then
	modifiers = true
else
	modifiers = false
end

print("IS MODIFIERS ENABLED ? " .. tostring(modifiers))

-- map_orig:read(50) -- empty bytes
-- readString(map_orig) -- next line
-- map_orig:read(18) -- empty bytes

-- STRING string which is built this way (map_xsize (in tiles) * map_ysize (in tiles)) + "x" + tile_count + "$" + CurrentSystemTime (HHMMSS) + "%" + SystemUpTime (in Milliseconds)
local info_string = readString(map_orig)
-- we'll ignore that above since doesn't make sense though
local tile_file_name = readString(map_orig) -- STRING filename of the tilset image (without path but with extension, "aztec.bmp" for example)

-- Read the number of tiles required from this tileset (tile_count) -1
local tileCount = map_orig:read(1):byte() -- BYTE number of tiles required from this tileset (tile_count) -1 (because it starts at 0)

-- Read map width (map_xsize) in tiles
local mapWidth = tonumber(dwordize(map_orig))

-- Read map height (map_ysize) in tiles
local mapHeight = tonumber(dwordize(map_orig))

-- Read filename of map background image (without path but with extension)
local mapBackgroundImageFilename = readString(map_orig) -- If there is no background it returns empty

-- Read map background scroll x speed
local mapBackgroundScrollXSpeed = tonumber(dwordize(map_orig)) -- IRRELEVANT
-- Read map background scroll y speed
local mapBackgroundScrollYSpeed = tonumber(dwordize(map_orig)) -- IRRELEVANT

-- Read map background color red
local mapBackgroundColorRed = tonumber(map_orig:read(1):byte())

-- Read map background color green
local mapBackgroundColorGreen = tonumber(map_orig:read(1):byte())

-- Read map background color blue
local mapBackgroundColorBlue = tonumber(map_orig:read(1):byte())

print("MAP NON-SENSE INFO : " .. info_string)
print("tile_file_name : " .. tile_file_name)
print("tileCount : " .. tileCount)
print("mapWidth : " .. mapWidth)
print("mapHeight : " .. mapHeight)
print("mapBackgroundImageFilename : " .. mapBackgroundImageFilename)
print("mapBackgroundScrollXSpeed : " .. mapBackgroundScrollXSpeed)
print("mapBackgroundScrollYSpeed : " .. mapBackgroundScrollYSpeed)
print("mapBackgroundColorRed : " .. mapBackgroundColorRed)
print("mapBackgroundColorGreen : " .. mapBackgroundColorGreen)
print("mapBackgroundColorBlue : " .. mapBackgroundColorBlue)

----- Header Test
-- STRING string to test if header is okay with value "ed.erawtfoslaernu" (unrealsoftware.de backwards)
local read_cs2d_string = tostring(readString(map_orig))
read_cs2d_string = read_cs2d_string:sub(1, -2) -- remove "\r" from last

assert(read_cs2d_string:reverse() == "unrealsoftware.de")

-- Reading tile modes
local tileModes = {}
for i = 0, tileCount do
    local tileMode = map_orig:read(1)
    table.insert(tileModes, string.byte(tileMode))
	-- print("TILE #"..i .. " - MODE : " .. string.byte(tileMode))
end

print("BEGIN")

local Frames = {}
local TileHeights = {}

for i = 0, mapWidth do
	Frames[i] = {}
	TileHeights[i] = {}
end

-- Assuming `save_tile_heights` is the value read from the header
local save_tile_heights = save_tileheights -- or 1, depending on the map's header data
local tile_count = tileCount  -- number of tiles, read from the header data

-- Function to read tile heights
local function readTileHeights(file, save_tile_heights, tile_count)
    local tile_heights = {}
    for i = 0, tile_count do
        if save_tile_heights == 1 then
            -- If save tile heights is 1, read an INT
            local height = dwordize(file)
            table.insert(tile_heights, height)
        elseif save_tile_heights == 2 then
            -- If save tile heights is 2, read a SHORT and a BYTE
            local height = readShort(file)
            local modifier = readByte(file)
            table.insert(tile_heights, {height = height, modifier = modifier})
        else
            -- Default heights if save_tile_heights is not 1 or 2
            local default_height = 0
            if tileModes[i] == 1 then
                default_height = 32  -- walls
            elseif tileModes[i] == 2 then
                default_height = 16  -- obstacles
            end
            table.insert(tile_heights, default_height)
        end
    end
    return tile_heights
end

-- usage
local tile_heights = readTileHeights(map_orig, save_tile_heights, tile_count)

local map_width = mapWidth  -- Replace with actual map width from header
local map_height = mapHeight -- Replace with actual map height from header
local use_map_modifiers = modifiers -- Replace with actual flag from header

-- Output the tile heights
for i, tile in ipairs(tile_heights) do
    if save_tile_heights == 2 then
        print(string.format("Tile %d - Height: %d, Modifier: %d", i-1, tile.height, tile.modifier))
    else
        print(string.format("Tile %d - Height: %d", i-1, tile))
    end
end

-- Read tile indices
local tile_indices = readTileIndices(map_orig, map_width, map_height)

-- Read tile modifiers if applicable
local tile_modifiers
if use_map_modifiers then
    tile_modifiers = readTileModifiers(map_orig, map_width, map_height)
end

-- Output the tile indices and modifiers for verification
for x = 0, map_width do
    for y = 0, map_height do
        print(string.format("Tile [%d, %d]: Index = %d", x, y, tile_indices[x][y]))
        if use_map_modifiers and tile_modifiers then
            local modifier = tile_modifiers[x][y].modifier
            print(string.format("Modifier = %d", modifier))
            if tile_modifiers[x][y].color then
                local color = tile_modifiers[x][y].color
                print(string.format("Color: R = %d, G = %d, B = %d", color.red, color.green, color.blue))
                print(string.format("Overlay Frame = %d", tile_modifiers[x][y].overlay_frame))
            elseif tile_modifiers[x][y].frame then
                print(string.format("Frame = %d", tile_modifiers[x][y].frame))
            elseif tile_modifiers[x][y].unused_string then
                print(string.format("Unused String = %s", tile_modifiers[x][y].unused_string))
            end
        end
    end
end

-- Read number of entities
local entity_count = tonumber(dwordize(map_orig))

print("ENTITY COUNT : " .. entity_count)

-- Iterate over each entity
for i = 1, entity_count do
    -- Read entity data
    local entity_name = readString(map_orig)
    local entity_type = tonumber(readByte(map_orig))
    local entity_x = tonumber(dwordize(map_orig))
    local entity_y = tonumber(dwordize(map_orig))
    local entity_triggers = readString(map_orig)
	
	print("#" .. i .." - ENTITY NAME : " .. entity_name)
	print("#" .. i .." - ENTITY TYPE : " .. entity_type)
	print("#" .. i .." - ENTITY X : " .. entity_x)
	print("#" .. i .." - ENTITY Y : " .. entity_y)
	print("#" .. i .." - ENTITY TRIGGERS : " .. entity_triggers)
    
    -- Iterate over entity settings
    for j = 1, 10 do
		local entity_int_setting = tonumber(dwordize(map_orig))
		local entity_str_setting = readString(map_orig)
		
		print("@" .. i .." - INT SETTING : " .. entity_int_setting)
		print("@" .. i .." - STRING SETTING : " .. entity_str_setting)
    end
end

-- What tile in the tileset [x, y] [num]
-- for x = 0, mapWidth do
	-- for y = 0, mapHeight do
		-- Frames[x][y] = tonumber(map_orig:read(1):byte())
		-- print("XY [" .. x .. " | " .. y .. "] - " .. Frames[x][y])
	-- end
-- end

print("END")

map_orig:close()